// intro.h
// Simple intro/cutscene generator.

// do_intro takes two parameters: first and last intro text portion to show.
// each text portion is a string (@ within a string is a line break) and is
// printed alongside a picture stored in the resource library.
// Text portion N will show picture BASE_PIC_RESOURCE + N.

#define INTRO_X				2		// Top-left X coordinate of text.
#define INTRO_Y 			17		// "   "    Y "          "  "
#define BASE_PIC_RESOURCE 	4		// Pic resources start here
#define INTRO_TEXT_COLOUR	71		// Text colour.
#define SCREEN_WAIT			250		// halts to wait after showing a screen.
#define LANG_TEXT_OFFS		7		// Add to message for second language text.

extern unsigned char intro_text_1 [0];
extern unsigned char intro_text_2 [0];
extern unsigned char intro_text_3 [0];
extern unsigned char intro_text_4 [0];


unsigned char *intro_texts [] = {
	intro_text_1, intro_text_2, intro_text_3, intro_text_4,

};

#asm
		;    "----------------------------OOOOOOOOOOOOOOOOOOOOOOOOOOOO----------------------------OOOOOOOOOOOOOOOOOOOOOOOOOOOO"
	._intro_text_1
		defm "'HACE MILENIOS EL UNIVERSO ESTUVO EN GUERRA'@LOS DIOSES AMENAZABAN TODA LA CREACION@EL CAOS DOMINABA EL MUNDO"
		defb 0
	._intro_text_2
		defm "POR VOLUNTAD DE 'LA FUENTE PRIMARIA'@FUISTE CREADO CON LUZ Y OSCURIDAD@LA VOLUNTAD DE UN MORTAL@EL PODER DE MATAR A UN DIOS"
		defb 0
	._intro_text_3
		defm "ANIQUILASTE A LOS DIOSES REBELDES@CANALIZASTE SUS PODERES HACIA 'LA FUENTE'@Y EL EQUILIBRIO SE RESTAURO@...HASTA AHORA"
		defb 0
	._intro_text_4
		defm "UN DIOS ASESINO A TU ESPOSA@DEBES VIAJAR POR EL ESPACIO-TIEMPO@EL EQUILIBRIO DEBE PRESERVARSE@..Y ALCANZAR TU VENGANZA"
		defb 0

#endasm

unsigned char introx, introy, stepbystep, character;
void show_intro_text (unsigned char *s) {
	introx = INTRO_X;
	introy = INTRO_Y;
	stepbystep = 1;
	while (*s) {
		character = (*s ++);
		if (character != '@') sp_PrintAtInv (introy, introx ++, INTRO_TEXT_COLOUR, character - 32);
		if (stepbystep) {
			#asm
				halt
				halt
				halt
				halt
			#endasm
			sp_UpdateNow ();
			#asm
				xor a
				in a, (254)
				cpl
				and 31
				jr z, _dafuq
			#endasm
			stepbystep = 0;		
			#asm
				._dafuq
			#endasm
		}
		if (character == '@') {introy += 2; introx = INTRO_X;}
	}
	if (!stepbystep) sp_UpdateNow ();
}

unsigned char intro_iterator;
void do_intro (unsigned char ini, unsigned char fin) {
	unsigned char text_offs = LANG_TEXT_OFFS * language;
	for (intro_iterator = ini; intro_iterator <= fin; intro_iterator ++) {
		sp_UpdateNow ();
		blackout_area ();
		get_resource (BASE_PIC_RESOURCE + intro_iterator, 16384);
		show_intro_text (intro_texts [intro_iterator + text_offs]);
		espera_activa (SCREEN_WAIT);
		sp_WaitForNoKey ();
	}
	blackout_area ();	
}
